<!-- Copyright (C) 2017-2020 Linagora

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. -->

<form novalidate [formGroup]="userManagementForm">
  <div fxLayout="column" class="user-form">
    <div fxLayout="column wrap" fxLayoutGap="10px">
      <div 
        fxLayoutAlign="start center" 
        fxLayoutAlign.md="center center" 
        fxLayoutAlign.sm="center center" 
        class="margin-top-x1"
      >
        <mat-form-field *ngIf="!editUser" fxFlex fxFlex.md="50%" fxFlex.sm="50%">
          <span matPrefix><mat-icon color="primary">person</mat-icon></span>
          <input matInput type="text" autocomplete="off" placeholder="Username" formControlName="username" [errorStateMatcher]="matcher">
          <mat-error *ngIf="formErrors.username"> {{ formErrors.username }} </mat-error>
        </mat-form-field>
      </div>
      <div fxLayoutAlign="start center" fxLayoutAlign.md="center center" fxLayoutAlign.sm="center center">
        <mat-form-field fxFlex fxFlex.md="50%" fxFlex.sm="50%">
          <span matPrefix><mat-icon color="primary">assignment_ind</mat-icon></span>
          <input matInput type="text" autocomplete="off" placeholder="Name" formControlName="name">
          <mat-error *ngIf="formErrors.name"> {{ formErrors.name }} </mat-error>
        </mat-form-field>
      </div>
      <div fxLayoutAlign="start center" fxLayoutAlign.md="center center" fxLayoutAlign.sm="center center">
        <mat-form-field fxFlex fxFlex.md="50%" fxFlex.sm="50%">
          <span matPrefix><mat-icon color="primary">vpn_key</mat-icon></span>
          <input matInput type="password" placeholder="Password" formControlName="password">
          <mat-error *ngIf="formErrors.password"> {{ formErrors.password }} </mat-error>
        </mat-form-field>
      </div>
      <div fxLayoutAlign="flex-end center" fxLayoutAlign.md="center center" fxLayoutAlign.sm="center center">
        <mat-slide-toggle 
          fxLayoutAlign="end center"
          fxLayoutAlign.md="center center"
          fxLayoutAlign.sm="center center"
          color="primary" 
          formControlName="isAdmin"
          [disabled]="isLastAdmin && currentUser.id === editUser.id"
        >
        Administrator
        </mat-slide-toggle>
      </div>

      <app-message
        *ngIf="isLastAdmin && (currentUser.id == editUser.id)"
        type="info"
        msg="You are the last administrator remaining."
        [isClosable]="false"
        class="info-admin-edit"
      ></app-message>
    </div>

    <mat-action-row 
      fxLayoutAlign="end center"
      fxLayoutAlign.md="center center"
      fxLayoutAlign.sm="center center"
      fxLayout.lt-md="column wrap"
      fxLayoutGap="10px"
      class="pnl-actions-user-management"
    >
      <button mat-raised-button type="button" class="btn-cancel-form text-upper" (click)="doCancel()">
        <mat-icon color="primary">cancel</mat-icon>
        <span class="cancel-name">Cancel</span>
      </button>
      <button 
        *ngIf="editUser" 
        mat-raised-button
        type="button" 
        (click)="doDelete()" 
        [disabled]="!canDelete"
        class="btn-delete-form text-upper"
      >
        <mat-icon color="warn">delete</mat-icon>
        <span class="delete-name">Delete</span>
      </button>
      <button
        mat-raised-button
        color="accent"
        type="button"
        (click)="doSubmit()"
        [disabled]="userManagementForm.invalid || userUnchanged()"
        class="btn-add-user-form text-upper"
      >
        <mat-icon>{{ editUser ? 'done' : 'person_add' }}</mat-icon>
        <span class="save-name">{{ editUser ? 'Save' : 'Add' }}</span>
      </button>
    </mat-action-row>
  </div>
</form>
